
public class Radix {

  static final int [] BIT = new int[32];

  static {
    int k = 1;
    for (int i = 0; i <= 31; i++) {
      BIT[i] = k;
      k *= 2;
    }
  }

  // Radix-exchange-sorting
  // (apply only to *positive* integers)   

  final static void radix(int[] a, int l, int r, int b) {

    if (b >= 0) {

      if ((r - l) <= 20) { 

       // Use Insertion-sorting for small arrays

       int i, j;
       for (i = l+1; i <= r; i++) {
         int v = a[i];
         for (j = i; l < j; j--) 
	   if (a[j-1] > v)
	     a[j] = a[j-1];
           else
	     break;
          a[j] = v;
        }
      }
      else {
  
        int i = l, j = r, t;
        do {
	  while ( ((a[i] & BIT[b]) == 0) && (i < j) ) i++;
	  while ( ((a[j] & BIT[b]) != 0) && (i < j) ) j--;
          t = a[i]; a[i] = a[j]; a[j] = t;
        } while (j != i);
  
        if ((a[r] & BIT[b]) == 0) j++;
  
        /*par_inv */
        {
          radix(a, l,j-1,b-1);
          radix(a, j,r,  b-1);
        }
      }
    }
  }
}
