/*  **********************************
    *** LoopWorker                 ***
    *** (C) 1996/1997 Aart Bik     ***
    *** Indiana University         ***
    ********************************** */

package parlooppack;

public abstract class LoopWorker extends Thread  { 

  // Instance Variables

  public int          low, high, stride;
  public LoopPool     pool;
  public RandomSync[] sync;

  // Class Method

  public static void parloop(int l, int h, LoopWorker[] w, int numS, int sched) {
     LoopPool     p = new LoopPool(l, h, w.length, sched);
     RandomSync[] s = new RandomSync[numS];

     for (int i = 0; i < numS; i++)
	s[i] = new RandomSync(l, h);

     // FORK
     for (int i = 0; i < w.length; i++) {
        w[i].pool = p; 
	w[i].sync = s;
        w[i].start();
     }

     // JOIN
     for (int i = 0; i < w.length; i++) { 
        try { w[i].join(); } 
        catch (Exception e) { }
     }
  }
}
